import Vue from 'vue' // 引入vue框架
import router from './router'
import VueI18n from 'vue-i18n' // 使用 国际化
import createI18n from './assets/languages' // 国际化定义
import VueForm from '@ezijing/vue-form'
import '@ezijing/vue-form/dist/vue-form.css'
import App from './app.vue' // 初始化 vue页面
import './style.scss' // 公共样式
import MetaInfo from 'vue-meta-info'
import Element from 'element-ui'
import modules from './modules'
import createBefore from './components/beforeEnter'
import store from './store'
import VueScrollmagic from 'vue-scrollmagic'
import './assets/css/reset.css'
import './assets/css/animate.min.css'
import './icons/index.js'

Vue.use(VueForm)

Vue.use(VueI18n)
const i18n = createI18n()
Vue.use(MetaInfo)
Vue.use(Element, { i18n: (key, value) => i18n.t(key, value) })
Vue.use(modules, { i18n })
Vue.use(VueScrollmagic)

/* 设置全局变量 */
window.G = Vue.prototype.$GLOBAL = {
  VERSION: 'PC-1.0.0'
}
window.Promise = Promise
/**
 * 定义全局变量 - 用作全局事件发布订阅
 * 使用 vue自带事件 $emit 和 $on 进行发布订阅
 */
Vue.prototype.VueEvent = new Vue()

// 百度统计
var _hmt = []
_hmt = _hmt || []
window._hmt = _hmt;
(function () {
  var hm = document.createElement('script')
  hm.src = 'https://hm.baidu.com/hm.js?bb0331ee1f5ca09758ebee99ec9c7b87'
  var s = document.getElementsByTagName('script')[0]
  s.parentNode.insertBefore(hm, s)
})()

/* 创建实例之前，通过导航守卫，处理部分逻辑，如：是否直接进入系统 */
const before = createBefore()
/* 导航守卫 */
router.beforeEach(async (to, from, next) => {
  if (_hmt) {
    if (to.path) {
      _hmt.push(['_trackPageview', '/#' + to.fullPath])
    }
  }
  await store.dispatch('generateRoutes')
  before.update(to, from, next)
})

window.G.$instance_vue = new Vue({
  router,
  store,
  i18n,
  render: h => h(App)
}).$mount('#app')
